<template>
  <div>

    <b-col lg="3" class="my-1 alert alert-success" v-if="search">
      <b-form-group
        label-align-sm="left"
        label-size="sm"
        label-for="filterInput"
        class="mb-0"
      >
        <b-input-group size="sm">
          <b-form-input
            v-model="filter"
            type="search"
            id="filterInput"
            placeholder="Nach Faktorwerten filtern..."
          ></b-form-input>
          <b-input-group-append>
            <b-button class="btn-success" :disabled="!filter" @click="filter = ''">Löschen</b-button>
          </b-input-group-append>
        </b-input-group>
      </b-form-group>
    </b-col>

    <!-- <b-col lg="6" class="my-1">
      <b-form-group
        label="Filter On"
        label-cols-sm="3"
        label-align-sm="right"
        label-size="sm"
        description="Leave all unchecked to filter on all data"
        class="mb-0">
        <b-form-checkbox-group v-model="filterOn" class="mt-1">
          <b-form-checkbox value="name">Name</b-form-checkbox>
          <b-form-checkbox value="age">Age</b-form-checkbox>
          <b-form-checkbox value="isActive">Active</b-form-checkbox>
        </b-form-checkbox-group>
      </b-form-group>
    </b-col> -->

    <b-table
      :items="getNItems(16)"
      :fields="fields"
      :small="true"
      :sort-by.sync="sortBy"
      :sort-desc.sync="sortDesc"
      :head-variant="light"
      sort-icon-right
      sticky-header="900px"
      :filter="filter"
      :filterIncludedFields="filterOn"
      @filtered="onFiltered"
      bordered
      hover
    >

      <!-- Col Group Header -->
      <template v-slot:thead-top="data" v-if="explanation">
        <tr>
          <th colspan="5" class="text-center">
            <hr style="position: relative; top: 30px; border-top: 4px solid #C0C0C0">
            <div class="colgroup">
              <span>Nicht für die Vorhersage verwendet</span>
            </div>
          </th>
          <th colspan="7" class="text-center">
            <span class="sr-only">{{ data.columns }}</span>
            <hr style="position: relative; top: 30px; border-top: 4px solid #C0C0C0">
            <div class="colgroup">
              <span>Für die Vorhersage verwendet</span>
            </div>
          </th>
          <th colspan="2" class="text-center">
            <hr style="position: relative; top: 30px; border-top: 4px solid #C0C0C0">
            <div class="colgroup">
              <span class="text-success">Vorhersage</span>
            </div>
          </th>
          <!-- <th colspan="1" class="text-center">
            <hr style="position: relative; top: 30px;">
            <div class="colgroup"><span>Reality</span></div>
          </th> -->
        </tr>
      </template>

      <!-- Filter Example -->
      <template :slot="`HEAD_${ key }`" v-for="key in fieldKeys" slot-scope="data">
        <span :key="key" class="text-info">{{ data }}</span>

        <select :key="key" class="form-control form-control-sm" @click.stop.prevent>
          <option :value="undefined">--</option>
        </select>

      </template>

      <!-- Format Column Header -->
      <template v-slot:head(Kredit_ID)="data">
        <div class="text-center">{{ data.label }}</div>
      </template>
      <template v-slot:head(Antragstellereinkommen)="data">
        <div class="text-center">{{ data.label }}</div>
      </template>
      <template v-slot:head(Mitantragstellereinkommen)="data">
        <div class="text-center">{{ data.label }}</div>
      </template>
      <template v-slot:head(Kredithoehe)="data">
        <div class="text-center">{{ data.label }}</div>
      </template>
      <template v-slot:head(Kreditlaufzeit)="data">
        <div class="text-center">{{ data.label }}</div>
      </template>
      <template v-slot:head(Geschlecht)="data">
        <div class="text-center">{{ data.label }}</div>
      </template>
      <template v-slot:head(Verheiratet)="data">
        <div class="text-center">{{ data.label }}</div>
      </template>
      <template v-slot:head(Angehoerige)="data">
        <div class="text-center">{{ data.label }}</div>
      </template>
      <template v-slot:head(Ausbildung)="data">
        <div class="text-center">{{ data.label }}</div>
      </template>
      <template v-slot:head(Selbstbeschaeftigt)="data">
        <div class="text-center">{{ data.label }}</div>
      </template>
      <template v-slot:head(Kreditgeschichte)="data">
        <div class="text-center">{{ data.label }}</div>
      </template>
      <template v-slot:head(Immobilienbereich)="data">
        <div class="text-center">{{ data.label }}</div>
      </template>
      <template v-slot:head(Kreditgewaehrung)="data">
        <div class="text-success text-center">{{ data.label }}</div>
      </template>
      <template v-slot:head(Kreditgewaehrung_prozentual)="data">
        <div class="text-success text-center">{{ data.label }}</div>
      </template>

      <!-- Kreditgewährung -->
      <template v-slot:cell(Kreditgewaehrung)="data">
        <div class="text-right" v-if="!isQuiz1 && !isQuiz2">{{ data.value }}</div>
        <div class="text-right" v-else-if="isQuiz1">
          <select name="decision_question" class="" v-model="pick" @change="getPick">
            <option value="Ja">Ja</option>
            <option value="Nein">Nein</option>
          </select>
        </div>
        <div class="text-right" v-else></div>
      </template>
      <!-- Kreditgewährung in Prozenten -->
      <template v-slot:cell(Kreditgewaehrung_prozentual)="data">
        <div class="text-right" v-if="!isQuiz1 && !isQuiz2">{{ data.value}}%</div>
        <div class="text-right" v-else></div>
      </template>

      <!-- Default SHAP cell -->
      <template v-slot:cell()="data">
        {{ data.value }}
      </template>

    </b-table>

    <!-- <p>
      Sorted by <b>{{ sortBy }}</b> in <b>{{ sortDesc ? 'Descending' : 'Ascending' }}</b> order.
    </p> -->

  </div>
</template>

<script>

export default {
  name: 'table-bootstrap-vue',
  props: [
    'explanation',
    'SHAP',
    'search',
    'isQuiz1',
    'isQuiz2',
    'pick'
  ],
  data () {
    return {
      sortBy: 'age',
      sortDesc: false,
      filter: null,
      filterOn: [],
      fields: [
        {
          key: 'Kredit_ID',
          label: 'Kredit-ID',
          sortable: this.isSortable(),
          class: 'col-shap',
          thAttr: this.theadColor()
        },
        {
          key: 'Antragstellereinkommen',
          label: 'Verdienst Haupt-A.',
          sortable: this.isSortable(),
          class: 'col-shap',
          thAttr: this.theadColor(),
          tdAttr: this.formatWithSHAP,
          formatter: 'toUSD'
        },
        {
          key: 'Mitantragstellereinkommen',
          label: 'Verdienst Mit-A.',
          sortable: this.isSortable(),
          class: 'col-shap',
          thAttr: this.theadColor(),
          tdAttr: this.formatWithSHAP,
          formatter: 'toUSD'
        },
        {
          key: 'Kredithoehe',
          label: 'Höhe des Kredits',
          sortable: this.isSortable(),
          class: 'col-shap',
          thAttr: this.theadColor(),
          tdAttr: this.formatWithSHAP,
          formatter: 'toUSD'
        },
        {
          key: 'Kreditlaufzeit',
          label: 'Laufzeit des Kredits',
          sortable: this.isSortable(),
          class: 'col-shap',
          thAttr: this.theadColor(),
          tdAttr: this.formatWithSHAP,
          tdClass: this.getGrid
        },
        {
          key: 'Geschlecht',
          sortable: this.isSortable(),
          class: 'col-shap',
          thAttr: this.theadColor(),
          tdAttr: this.formatWithSHAP
        },
        {
          key: 'Verheiratet',
          sortable: this.isSortable(),
          class: 'col-shap',
          thAttr: this.theadColor(),
          tdAttr: this.formatWithSHAP
        },
        {
          key: 'Angehoerige',
          label: 'Angehörige',
          sortable: this.isSortable(),
          class: 'col-shap',
          thAttr: this.theadColor(),
          tdAttr: this.formatWithSHAP
        },
        {
          key: 'Ausbildung',
          sortable: this.isSortable(),
          class: 'col-shap',
          thAttr: this.theadColor(),
          tdAttr: this.formatWithSHAP
        },
        {
          key: 'Selbstbeschaeftigt',
          label: 'Selbstständig',
          sortable: this.isSortable(),
          class: 'col-shap',
          thAttr: this.theadColor(),
          tdAttr: this.formatWithSHAP
        },
        {
          key: 'Kreditgeschichte',
          label: 'Kreditauskunft des Antragstell.',
          sortable: this.isSortable(),
          class: 'col-shap',
          thAttr: this.theadColor(),
          tdAttr: this.formatWithSHAP
        },
        {
          key: 'Immobilienbereich',
          label: 'Immobilienlage des Antragstellers',
          sortable: this.isSortable(),
          class: 'col-shap',
          thAttr: this.theadColor(),
          tdAttr: this.formatWithSHAP,
          tdClass: this.getGrid
        },
        {
          key: 'Kreditgewaehrung',
          label: 'Kredit gewährt laut System',
          sortable: this.isSortable(),
          class: '',
          thAttr: this.theadColor()
        },
        {
          key: 'Kreditgewaehrung_prozentual',
          label: 'Kreditgewährung in Prozenten',
          sortable: this.isSortable(),
          class: '',
          thAttr: this.theadColor()
        }
      ]
    }
  },
  computed: {
    fieldKeys () {
      return Object.keys(this.SHAP[0])
    },
    sortOptions () {
      // Create an options list from our fields
      return this.fields
        .filter(f => f.sortable)
        .map(f => {
          return {
            text: f.label,
            value: f.key
          }
        })
    }
  },
  methods: {
    getNItems (n) {
      return this.SHAP.slice(0, n)
    },
    // format as %
    toPercent (value) {
      return value.toLocaleString('en', { style: 'percent' })
    },
    // format as USD
    toUSD (value) {
      return new Intl.NumberFormat('en-EN', {
        style: 'currency',
        currency: 'USD'
      }).format(value)
    },
    // Color cell according to SHAP value
    formatWithSHAP: function (value, key, item) {
      if (this.explanation) {
        var shapValue = item['Shap ' + key + ' in %']
        var shapValueAbs = (Math.abs(shapValue) / 100)
        var opacity = Math.abs(shapValueAbs) * 5
        var attr = {}
        /* if (shapValueAbs < 0.02) {
             attr.style = 'opacity: 0.3;'
          } else */
        if (shapValue > 0) {
          attr.style = `background-color: rgba(255,0,81,${opacity})`
        } else {
          attr.style = `background-color: rgba(0,139,251,${opacity})`
        }
        // Add title @TODO: Add Tooltip
        // attr.title = 'SHAP Value: ' + this.toPercent(shapValue)
        return attr
      } else {
        return null
      }
    },
    // add border-right in order to make included and excluded from model visible inside of table
    getGrid: function () {
      if (this.explanation) {
        var attr = {}
        attr = 'explanation-grid'
        return attr
      } else {
        return null
      }
    },
    // BUGFIX colours thead if explanation flag is not set
    theadColor: function () {
      var attr = {}
      attr.style = 'background-color: #e9ecef'
      return attr
    },
    isSortable: function () {
      if (this.isQuiz1 || this.isQuiz2) {
        return false
      } else {
        return true
      }
    },
    getPick: function () {
      this.$emit('getPickInParent', this.pick)
    }
  },
  mounted: function () {
    console.log(this.fieldKeys())
  }
}
</script>
<style>

  .col-shap {
    cursor: help;
    text-align: right;
    padding-right: 10px !important;
    padding-left: 10px !important;
    width: 7%;
    /* white-space: nowrap;  */
  }

  .col-truncate {
    max-width: 150px;
    /* background: red; */
    white-space: nowrap;
    overflow: hidden;
    text-overflow: ellipsis;
  }

  .colgroup {
    border-left: 2px solid #C0C0C0;
    border-right: 2px solid #C0C0C0;
    /* border-bottom: 2px solid lightgray; */
    /* border-top: 2px solid lightgray; */
    text-transform: uppercase;
    font-weight: bolder;
  }

  .colgroup span {
    position: relative;
    background-color: white;
    padding: 0px 5px;
  }

  .thead-light tr:first-child th {
    background-color: white;
    padding-top: 15px;
    padding-bottom: 15px;
    border: 0;
  }

  .explanation-grid {
    border-right: 2px solid #C0C0C0 !important;
  }

</style>
